unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TDrawThread }

  TDrawThread = class(TThread)
  private
    FTempBitmap: TBitmap;
    FUpdateImage: Boolean;
    procedure UpdateVisual;
  protected
    procedure Execute; override;
  public
    constructor Create;
    destructor Destroy; override;
  public
    property UpdateImage: Boolean read FUpdateImage write FUpdateImage;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    tmWait: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tmWaitTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

var
  DrawThread: TDrawThread = nil;

procedure TForm1.FormShow(Sender: TObject);
begin
  tmWait.Enabled := True;
end;

procedure TForm1.tmWaitTimer(Sender: TObject);
begin
  tmWait.Enabled := False;
  DrawThread := TDrawThread.Create;
  DrawThread.FreeOnTerminate := True;
  DrawThread.UpdateImage := False;
  DrawThread.Start
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(DrawThread) then
    DrawThread.Terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Assigned(DrawThread) then
    DrawThread.UpdateImage := True;
end;

{ TDrawThread }

procedure TDrawThread.UpdateVisual;
begin
  Form1.Image1.Picture.Bitmap.Assign(FTempBitmap);
end;

procedure TDrawThread.Execute;
begin
  while not Terminated do
  begin
    if FUpdateImage then
    begin
      FUpdateImage := False;
      Synchronize(@UpdateVisual);
    end;
    Sleep(1);
  end;
end;

constructor TDrawThread.Create;
begin
  inherited Create(True);
  FTempBitmap := TBitmap.Create;
  FTempBitmap.SetSize(1000, 600);
  with FTempBitmap.Canvas do
  begin
    Brush.Color := clBlack;
    FillRect(0, 0, FTempBitmap.Width, FTempBitmap.Height);
    Pen.Color := clRed;
    Line(5, 5, 200, 5);
    Pen.Color := clGreen;
    Ellipse(10, 10, 400, 200);
  end;
end;

destructor TDrawThread.Destroy;
begin
  //..
  inherited;
end;

end.

